/*

   HOTEL.POV

   Jaime Vives Piqueres, (?)2000.

*/

// *** STANDARD INCLUDES ***
#include "colors.inc"
#include "textures.inc"
#include "stones.inc"
#include "metals.inc"
#include "golds.inc"
#include "woods.inc"
#include "skies.inc"

// *** custom includes ***
#include "meshlath.inc"

// *** CONTROL ***
#declare test_glass       =1;
#declare use_test_lights  =0;
#declare use_wall_lights  =1;
#declare use_room_lights  =0;
#declare use_plants       =1;
#declare use_steps        =1;
#declare use_carrito      =0;
#declare use_exitlight    =1;
#declare use_papercans    =1;
#declare use_carpets      =1;
#declare use_parquet      =1;
#declare use_room_doors   =1;
#declare use_final_text   =0;
#declare use_soft_wood    =1;
#declare usar_area        =1;
#declare usar_radiosidad  =1;
#declare high_quality     =0; //rad


// *** CAMERA SELECTION ***
// see i_camera.inc for different camera numbers
#declare c_sel=4;


// *** GLOBBAL SETTINGS ***
global_settings{
 max_trace_level 16
 #if (usar_radiosidad)
  ambient_light 0.0
  #include "i_radiosity.inc"
 #end
}


// *** COMMON MEASURES ***
#declare doorh_w=80;
#declare doorh_h=200;
#declare wall_l=doorh_w*16;
#declare wall_h=260;
#declare wall_d=20;
#declare corridor_w=250;
#declare ceil_t=wall_d;
#declare esc_d=25;
#declare num_esc=9;
#declare esc_h=wall_h*.5/9;
#declare baran_h=90;
#declare rbs=1;


// *** COMMON TEXTURES ***
#include "i_textures.inc"



// **************************
// *** OBJECT DECLARATION ***
// **************************

// *** WALLS ***
#include "i_corridor.inc"

// *** ROOM DOORS ***
#if (use_room_doors)
 #include "i_room_door.inc"
#end

// *** STEPS ***
#if (use_steps)
 #include "i_steps.inc"
#end

// *** PAPERCANS ***
#if (use_papercans)
 #include "i_papercan.inc"
#end

// *** CARPETS ***
#if (use_carpets)
 #include "i_carpet.inc"
#end

// *** PLANTS ON THE CORNERS ***
#if (use_plants)
 #include "i_plant.inc"
#end

// *** CARRITO DE LA LIMPIEZA ***
#if (use_carrito)
 #include "i_carrito.inc"
#end

// *** LIGHTS ***
#if (use_wall_lights)
 #include "i_lights.inc"
#end
#if (use_exitlight)
 #include "i_exitl.inc"
#end


// ************************
// *** OBJECT PLACEMENT ***
// ************************

// *** CORRIDOR ***
// left wall
object{doors_wall
 rotate 90*y
 translate -(corridor_w*.5+wall_d*.5)*x
}
// right wall
object{doors_wall
 rotate -90*y
 translate (corridor_w*.5+wall_d*.5)*x
}
// corridor
object{corridor_ceil
 translate (wall_h+ceil_t*.5)*y
}
// foreg corridor
object{corridor_ceil
 rotate 90*y
 translate (wall_h+ceil_t*.5)*y
 translate (-wall_l*.5-corridor_w*.5)*z
}
// backg corridor
object{corridor_ceil
 rotate 90*y
 translate (wall_h+ceil_t*.5)*y
 translate (wall_l*.5+corridor_w*.5)*z
}
// left rooms
object{rooms_ceil
 translate <-corridor_w*.5-wall_l*.5,wall_h+ceil_t*.5,0>
}
// right rooms
object{rooms_ceil
 translate <corridor_w*.5+wall_l*.5,wall_h+ceil_t*.5,0>
}
// foreg right
object{basic_wall
 translate <wall_l*.5+corridor_w*.5,0,-wall_l*.5+wall_d*.5>
}
// foreg left
object{basic_wall
 translate <-wall_l*.5-corridor_w*.5,0,-wall_l*.5+wall_d*.5>
}
// foreg center
object{basic_wall
 translate <0,0,-wall_l*.5-corridor_w>
}
// backg right
object{basic_wall
 translate <wall_l*.5+corridor_w*.5,0,wall_l*.5-wall_d*.5>
}
object{doors_wall
 rotate 180*y
 translate <wall_l*.5+corridor_w*.5,0,wall_l*.5+corridor_w+wall_d*.5>
}
// backg left
object{basic_wall
 translate <-wall_l*.5-corridor_w*.5,0,wall_l*.5-wall_d*.5>
}
object{doors_wall
 rotate 180*y
 translate <-wall_l*.5-corridor_w*.5,0,wall_l*.5+corridor_w+wall_d*.5>
}
// back corridor end walls
object{basic_wall
 rotate 90*y
 translate <-wall_l*.5,0,wall_l>
}
object{basic_wall
 rotate 90*y
 translate <wall_l*.5,0,wall_l>
}
// steps walls
object{basic_wall
 rotate 90*y
 translate <-(corridor_w*.5+wall_d*.5),0,wall_l+corridor_w>
}
object{basic_wall
 rotate 90*y
 translate <(corridor_w*.5+wall_d*.5),0,wall_l+corridor_w>
}
object{basic_wall
 translate <0,0,wall_l*.5+corridor_w+esc_d*num_esc+corridor_w>
}
union{
object{basic_wall
 rotate 90*y
 translate <-(corridor_w*.5+wall_d*.5),0,wall_l+corridor_w>
}
object{basic_wall
 rotate 90*y
 translate <(corridor_w*.5+wall_d*.5),0,wall_l+corridor_w>
}
object{basic_wall
 translate <0,0,wall_l*.5+corridor_w+esc_d*num_esc+corridor_w>
}
translate -wall_h*y
}
union{
object{basic_wall
 rotate 90*y
 translate <-(corridor_w*.5+wall_d*.5),0,wall_l+corridor_w>
}
object{basic_wall
 rotate 90*y
 translate <(corridor_w*.5+wall_d*.5),0,wall_l+corridor_w>
}
object{basic_wall
 translate <0,0,wall_l*.5+corridor_w+esc_d*num_esc+corridor_w>
}
translate wall_h*y
}
// rooms back wall
object{basic_wall
 rotate 90*y
 translate <-corridor_w*.5-wall_l,0,0>
}
object{basic_wall
 rotate 90*y
 translate <corridor_w*.5+wall_l,0,0>
}
// corridors floors
union{
object{corridor_floor rotate 90*y}
object{corridor_floor
 translate <0,0,wall_l*.5+corridor_w*.5>
}
object{corridor_floor
 translate <0,0,-wall_l*.5-corridor_w*.5>
}
translate -1*y
}
// rooms floor
object{rooms_floor
 translate <-corridor_w*.5-wall_l*.5,0,0>
}
object{rooms_floor
 translate <corridor_w*.5+wall_l*.5,0,0>
}


// *** STEPS ***
#if (use_steps)
object{escalera
 translate <-corridor_w*.5+corridor_w*.2,0,wall_l*.5+corridor_w>
}
object{barandilla
 texture{t_rdoor_wood rotate 90*x}
 translate <0,baran_h*.5,wall_l*.5+corridor_w+2.5>
}
object{barandilla
 texture{t_rdoor_wood rotate 90*x}
 translate <-esc_d*.5,baran_h*.5,wall_l*.5+corridor_w+2.5>
}
object{barandilla
 texture{t_rdoor_wood rotate 90*x}
 translate <esc_d*.5,baran_h*.5,wall_l*.5+corridor_w+2.5>
}
object{barandilla
 texture{t_rdoor_wood rotate 90*x}
 translate <-esc_d,baran_h*.5,wall_l*.5+corridor_w+2.5>
}
object{barandilla
 texture{t_rdoor_wood rotate 90*x}
 translate <esc_d,baran_h*.5,wall_l*.5+corridor_w+2.5>
}
object{rellano
 texture{t_rdoor_wood rotate 90*y}
 translate <0,esc_h*.5+esc_h*(num_esc-1),esc_d*.5+esc_d*(num_esc-1)+corridor_w*.5>
 translate <0,0,wall_l*.5+corridor_w>
}
object{pared_rellano
 texture{t_rdoor_wood rotate 90*x}
 translate <0,wall_h*.15+esc_h+esc_h*(num_esc-1),esc_d*.5+esc_d*(num_esc-1)+corridor_w*.5>
 translate <0,0,wall_l*.5+corridor_w>
}
union{
object{barandilla
 texture{t_rdoor_wood rotate 90*x}
 translate <0,baran_h*.5,wall_l*.5+corridor_w+2.5>
}
object{barandilla
 texture{t_rdoor_wood rotate 90*x}
 translate <-esc_d*.5,baran_h*.5,wall_l*.5+corridor_w+2.5>
}
object{barandilla
 texture{t_rdoor_wood rotate 90*x}
 translate <esc_d*.5,baran_h*.5,wall_l*.5+corridor_w+2.5>
}
object{barandilla
 texture{t_rdoor_wood rotate 90*x}
 translate <-esc_d,baran_h*.5,wall_l*.5+corridor_w+2.5>
}
object{barandilla
 texture{t_rdoor_wood rotate 90*x}
 translate <esc_d,baran_h*.5,wall_l*.5+corridor_w+2.5>
}
 translate <0,esc_h*num_esc,esc_d*num_esc>
}
object{escalera
 rotate 180*y
 translate <corridor_w*.5-corridor_w*.2,wall_h*.5,wall_l*.5+corridor_w+num_esc*esc_d>
}
object{escalera
 rotate 180*y
 translate <corridor_w*.5-corridor_w*.2,-wall_h*.5,wall_l*.5+corridor_w+num_esc*esc_d>
}
object{escalera
 translate <-corridor_w*.5+corridor_w*.2,wall_h,wall_l*.5+corridor_w>
}
object{escalera
 translate <-corridor_w*.5+corridor_w*.2,-wall_h,wall_l*.5+corridor_w>
}
object{rellano
 texture{t_rdoor_wood rotate 90*y}
 translate <corridor_w*.5-corridor_w*.2,esc_h*.5+esc_h*(num_esc-1),esc_d*.5+esc_d*(num_esc-1)+corridor_w*.5>
 translate <-corridor_w*.5+corridor_w*.2,-wall_h,wall_l*.5+corridor_w>
}
object{pared_rellano
 texture{t_rdoor_wood rotate 90*x}
 translate <0,wall_h*.15+esc_h+esc_h*(num_esc-1),esc_d*.5+esc_d*(num_esc-1)+corridor_w*.5>
 translate <0,-wall_h,wall_l*.5+corridor_w>
}
#end


// *** ROOM DOORS ***
#if (use_room_doors)
// doors
#declare r_door=seed(1637);
object{room_door(r_door,"37",0)
 rotate -90*y
 translate <-corridor_w*.5-wall_d*.5,doorh_h*.5,-wall_l*.5+wall_l*.25>
}
object{room_door(r_door,"39",60)
 rotate -90*y
 translate <-corridor_w*.5-wall_d*.5,doorh_h*.5,-wall_l*.5+wall_l*.5>
}
object{room_door(r_door,"41",0)
 rotate -90*y
 translate <-corridor_w*.5-wall_d*.5,doorh_h*.5,-wall_l*.5+wall_l*.75>
}
object{room_door(r_door,"38",0)
 rotate 90*y
 translate <corridor_w*.5+wall_d*.5,doorh_h*.5,-wall_l*.5+wall_l*.25>
}
object{room_door(r_door,"40",0)
 rotate 90*y
 translate <corridor_w*.5+wall_d*.5,doorh_h*.5,-wall_l*.5+wall_l*.5>
}
object{room_door(r_door,"42",0)
 rotate 90*y
 translate <corridor_w*.5+wall_d*.5,doorh_h*.5,-wall_l*.5+wall_l*.75>
}
#end


// *** ROOM LIGHT ***
#if (use_room_lights)
light_source{
 0
 White*.4+Gold*.3
 #if (usar_area)
 area_light <9,0,0>,<0,0,9>,4,4 jitter adaptive 1
 #end
 fade_distance wall_l*.3
 fade_power 4
 translate <-corridor_w,wall_h*.9,-wall_l*.5+wall_l*.5>
}
#end


// *** PAPERCANS ***
#if (use_papercans)
object{papercan
 rotate -3*y
 translate <1,.1,wall_l*.5+corridor_w-29>
}
object{papercan
 rotate -3*y
 translate <1,wall_h*.5+.1,wall_l*.5+corridor_w+esc_d*num_esc+corridor_w-29>
}
#end


// *** CARPETS ***
#if (use_carpets)
object{red_carpet
 rotate 90*y
}
object{red_carpet
 translate <0,0,wall_l*.5+corridor_w*.5>
}
#end


// *** PLANTS ***
#if (use_plants)
#declare r_p=seed(6743);
/*
take one
object{corner_plant
 rotate 360*rand(r_p)*y
 translate <-corridor_w*.5+25,0,-wall_l*.5+wall_l*.875>
}
object{corner_plant
 rotate 360*rand(r_p)*y
 translate <corridor_w*.5-26,0,-wall_l*.5+wall_l*.875>
}
object{corner_plant
 rotate 360*rand(r_p)*y
 translate <-corridor_w*.5+25,0,-wall_l*.5+wall_l*.125>
}
object{corner_plant
 rotate 360*rand(r_p)*y
 translate <corridor_w*.5-26,0,-wall_l*.5+wall_l*.125>
}
object{corner_plant
 rotate 360*rand(r_p)*y
 translate <-corridor_w*.5+25,wall_h*.5,wall_l*.5+corridor_w+esc_d*num_esc+corridor_w-26>
}
*/
// take two
object{corner_plant
 rotate 360*rand(r_p)*y
 translate <-corridor_w*.5+25,wall_h*.5,wall_l*.5+corridor_w+esc_d*num_esc+corridor_w-26>
}
object{corner_plant
 rotate 360*rand(r_p)*y
 translate <corridor_w*.5-25,-wall_h*.5,wall_l*.5+corridor_w+esc_d*num_esc+corridor_w-26>
}
#end


// *** WALL LIGHTS ***
#if (use_wall_lights)
#declare ld=10;
#declare light_h=165;
#declare r_lamp=seed(567);
object{wall_light(r_lamp,1)
 rotate 90*y
 translate <corridor_w*.5-ld,light_h,-wall_l*.125>
}
object{wall_light(r_lamp,1)
 rotate -90*y
 translate <-corridor_w*.5+ld,light_h,wall_l*.125>
}
object{wall_light(r_lamp,1)
 rotate -90*y
 translate <-corridor_w*.5+ld,light_h,-wall_l*.125>
}
object{wall_light(r_lamp,1)
 rotate 90*y
 translate <corridor_w*.5-ld,light_h,wall_l*.125>
}
/*object{wall_light(r_lamp,1)
 rotate 90*y
 translate <corridor_w*.5-ld,light_h,-wall_l*.375>
}
object{wall_light(r_lamp,1)
 rotate -90*y
 translate <-corridor_w*.5+ld,light_h,-wall_l*.375>
}*/
object{wall_light(r_lamp,1)
 rotate 90*y
 translate <corridor_w*.5-ld,light_h,wall_l*.375>
}
object{wall_light(r_lamp,1)
 rotate -90*y
 translate <-corridor_w*.5+ld,light_h,wall_l*.375>
}
object{wall_light(r_lamp,1)
 translate <-corridor_w*.5-wall_l*.125,light_h,wall_l*.5+corridor_w-wall_d*.5-ld>
}
object{wall_light(r_lamp,1)
 translate <corridor_w*.5+wall_l*.125,light_h,wall_l*.5+corridor_w-wall_d*.5-ld>
}
object{wall_light(r_lamp,1)
 rotate 180*y
 translate <-corridor_w*.5-wall_l*.125,light_h,wall_l*.5+ld>
}
object{wall_light(r_lamp,1)
 rotate 180*y
 translate <corridor_w*.5+wall_l*.125,light_h,wall_l*.5+ld>
}
// escalera
#if (use_test_lights=0)
object{wall_light(r_lamp,1)
 rotate 90*y
 translate <corridor_w*.5-ld,light_h-esc_h*4,wall_l*.5+corridor_w+esc_d*4>
}
object{wall_light(r_lamp,1)
 rotate -90*y
 translate <-corridor_w*.5+ld,light_h+esc_h*4,wall_l*.5+corridor_w+esc_d*4>
}
object{wall_light(r_lamp,1)
 translate <0,light_h+wall_h*.5,wall_l*.5+corridor_w*2+esc_d*num_esc-wall_d*.5-ld>
}
object{wall_light(r_lamp,1)
 translate <0,light_h-wall_h*.5,wall_l*.5+corridor_w*2+esc_d*num_esc-wall_d*.5-ld>
}
#end
#end


// *** CARRITO DE LA LIMPIEZA ***
#if (use_carrito)
object{carrito
 rotate -39*y
 translate <-28,0,50>
}
#end


// *** EXIT & EMERGENCY LIGHTS ***
#if (use_exitlight)
object{exit_light translate <-corridor_w*.5-25,230,wall_l*.5+corridor_w*.96>}
#declare boca_incendios=
union{
 difference{
  box{-.5,.5}
  box{-.5,.5 scale .98}
  box{-.5,.5 scale .9 translate -.1*z}
  scale <55,55,13>
  texture{pigment{Red} finish{Shiny} normal{granite}}
 }
 difference{
  box{-.5,.5}
  box{-.5,.5 scale <.95,.95,1.1>}
  scale <50,50,.2>
  texture{Chrome_Metal}
  translate -6.5*z
 }
 box{-.5,.5
  texture{
   material_map{
    tga "mm_fire"
    texture{Glass}
    texture{pigment{White} finish{Shiny}}
   }
   translate -.5
  }
  scale <54,54,.1>
  translate -6.1*z
 }
 union{
  cylinder{<20,17,5>,<20,17,7>,3}
  intersection{
   torus{5,2 rotate 90*z}
   plane{y,0 inverse}
   plane{z,0}
   translate <20,12,5>
  }
  cylinder{<20,10,0>,<20,-10,0>,2}
  cylinder{<20,0,0>,<17,0,0>,2}
  cylinder{<20,12,0>,<20,10,0>,3}
  cylinder{<20,-10,0>,<20,-12,0>,3}
  intersection{
   torus{5,2 rotate 90*z}
   plane{y,0}
   plane{z,0}
   translate <20,-12,5>
  }
  cylinder{<20,-17,5>,<20,-17,7>,3}
  texture{Gold_Metal}
 }
 height_field{
  png "hf_toallas"
  water_level .01
  translate -.5
  rotate -90*x
  rotate 90*z
  scale <20,50,8>
  texture{
   pigment{White*.9+Yellow*.1}
   normal{wrinkles}
   finish{Phong_Dull}
  }
  translate -5*x
 }
}
object{boca_incendios
 rotate -90*y
 translate <-corridor_w*.5+6.6,115,-wall_l*.5+115>
}
#end

// *** "DO NOT DISTURB" ON LEFT FIRST DOOR ***
difference{
 box{-.5,.5 scale <8,16,.1>}
 box{-.5,.5 scale <3,2,.2> translate <0,5,0>}
 texture{
  pigment{
   image_map{
    png "im_bote3"
   }
   translate -.5
   scale <8,16,1>
  }
 }
 rotate 87*y
 translate <corridor_w*.5+wall_d*.5-3,doorh_h*.5-doorh_h*.08-5,-wall_l*.5+wall_l*.25+doorh_w*.37>
}

// **************
// *** CAMERA ***
// **************

// settings are in the same scale as the whole scene
#include "i_camera.inc"
camera{
 location c_from
// right <3.6,0,0> up <0,2.4,0> // universal film
 right <3.2,0,0> up <0,2.4,0> // universal film
 direction c_dir
 look_at c_to
// normal{wrinkles .025 scale 10}
}


