// *** THAT'S MEGAPOV CODE ***
#version unofficial MegaPov 0.5;

// *** wood board macro ***
#macro tablon(xs,ys,zs,r_wood,t_wood)
box{-.5,.5
 scale <xs,ys,zs>
 texture{t_wood
  rotate 90*x
  scale 32
  translate 100*rand(r_wood)*x
 }
 texture{
  pigment{
   cylindrical
   turbulence .01
   color_map{
    [0.0 DarkBrown filter .1]
    [1.0 DarkBrown filter .9]
   }
   scale 2
   scale <xs,ys,zs>
  }
 }
 #if (use_final_text)
 texture{t_dirtyvw
  translate 100*rand(r_wood)*x
 }
 #end
}
#end
#macro tablon_hx(xs,ys,zs,r_wood,t_wood)
#if (use_final_text)
union{
 box{<-.5,-.5,-.45>,<.5,.5,.5> scale <xs,ys,zs>}
 height_field{
  pattern
   #if (use_soft_wood)
    xs*3, ys*3{
   #else
    xs*.5, ys*.5{
   #end
   hf_gray_16
   wood
   turbulence .4
   lambda 3
   pigment_map{
    [0.00 White]
    [1.00 Gray10]
   }
   scale <xs*.1,zs*.1,ys*.1>
   scale 1
   translate 100*rand(r_wood)*z
  }
  translate -.5
  rotate -90*x
  scale <xs,ys,zs>
  translate -.5*z
 }
 texture{t_wood
  rotate 90*x
  scale 32
  translate 100*rand(r_wood)*x
 }
 texture{
  pigment{
   cylindrical
   turbulence .01
   color_map{
    [0.0 DarkBrown filter .1]
    [1.0 DarkBrown filter .9]
   }
   scale 2
   scale <xs,ys,zs>
  }
 }
 texture{t_dirtyvw
  translate 100*rand(r_wood)*x
 }
 rotate 180*y
}
#else
box{-.5,.5
 scale <xs,ys,zs>
 texture{t_wood
  rotate 90*x
  scale 32
  translate 100*rand(r_wood)*x
 }
 texture{
  pigment{
   cylindrical
   turbulence .01
   color_map{
    [0.0 DarkBrown filter .1]
    [1.0 DarkBrown filter .9]
   }
   scale 2
   scale <xs,ys,zs>
  }
 }
}
#end
#end


// basic wall with 4 holes for doors
#declare doors_wall=
union{
 difference{
  box{-.5,.5
   scale <wall_l,wall_h,wall_d>
   translate wall_h*.5*y
  }
  box{-.5,.5
   scale <doorh_w,doorh_h,wall_d*1.1>
   translate <-wall_l*.5+wall_l*.25,doorh_h*.5,0>
  }
  box{-.5,.5
   scale <doorh_w,doorh_h,wall_d*1.1>
   translate <-wall_l*.5+wall_l*.5,doorh_h*.5,0>
  }
  box{-.5,.5
   scale <doorh_w,doorh_h,wall_d*1.1>
   translate <-wall_l*.5+wall_l*.75,doorh_h*.5,0>
  }
  hollow
  texture{t_doors_wpaper}
 }
 union{
  #declare r_board=seed(629);
  #declare wboard_w=(wall_l*.25-doorh_w*.5)/10;
  union{
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*0,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*1,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*2,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*3,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*4,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*5,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*6,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*7,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*8,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*9,0,0>
  }
  object{tablon(2,wboard_w*10,4,r_board,t_rdoor_wood)
   rotate 90*z
   translate <-wall_l*.5+wboard_w*5,wall_h*.15+1,0>
  }
  object{tablon(10,wboard_w*10,4,r_board,t_rdoor_wood)
   rotate 90*z
   translate <-wall_l*.5+wboard_w*5,-wall_h*.15+5,0>
  }
  translate <0,wall_h*.15,wall_d*.5+1>
  }
  #declare wboard_w=(wall_l*.25-doorh_w*.5)/10;
  union{
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*0,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*1,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*2,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*3,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*4,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*5,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*6,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*7,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*8,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*9,0,0>
  }
  object{tablon(2,wboard_w*10,4,r_board,t_rdoor_wood)
   rotate 90*z
   translate <-wall_l*.5+wboard_w*5,wall_h*.15+1,0>
  }
  object{tablon(10,wboard_w*10,4,r_board,t_rdoor_wood)
   rotate 90*z
   translate <-wall_l*.5+wboard_w*5,-wall_h*.15+5,0>
  }
  translate <wall_l*.75+doorh_w*.5,wall_h*.15,wall_d*.5+1>
  }
  #declare wboard_w=(wall_l*.25-doorh_w)/8;
  union{
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*0,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*1,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*2,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*3,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*4,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*5,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*6,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*7,0,0>
  }
  object{tablon(2,wboard_w*8,4,r_board,t_rdoor_wood)
   rotate 90*z
   translate <-wall_l*.5+wboard_w*4,wall_h*.15+1,0>
  }
  object{tablon(10,wboard_w*8,4,r_board,t_rdoor_wood)
   rotate 90*z
   translate <-wall_l*.5+wboard_w*4,-wall_h*.15+5,0>
  }
  translate <wall_l*.25+doorh_w*.5,wall_h*.15,wall_d*.5+1>
  }
  #declare wboard_w=(wall_l*.25-doorh_w)/8;
  union{
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*0,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*1,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*2,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*3,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*4,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*5,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*6,0,0>
  }
  object{tablon_hx(wboard_w*.98,wall_h*.3,1,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wboard_w*.5+wboard_w*7,0,0>
  }
  object{tablon(2,wboard_w*8,4,r_board,t_rdoor_wood)
   rotate 90*z
   translate <-wall_l*.5+wboard_w*4,wall_h*.15+1,0>
  }
  object{tablon(10,wboard_w*8,4,r_board,t_rdoor_wood)
   rotate 90*z
   translate <-wall_l*.5+wboard_w*4,-wall_h*.15+5,0>
  }
  translate <wall_l*.5+doorh_w*.5,wall_h*.15,wall_d*.5+1>
  }
  // door joints
  object{tablon(1,wall_h*.3,wall_d*.5,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wall_l*.25+doorh_w*.5-1,wall_h*.15,wall_d*.25+1>
  }
  object{tablon(1,wall_h*.3,wall_d*.5,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wall_l*.25-doorh_w*.5+1,wall_h*.15,wall_d*.25+1>
  }
  object{tablon(1,wall_h*.3,wall_d*.5,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wall_l*.50+doorh_w*.5-1,wall_h*.15,wall_d*.25+1>
  }
  object{tablon(1,wall_h*.3,wall_d*.5,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wall_l*.50-doorh_w*.5+1,wall_h*.15,wall_d*.25+1>
  }
  object{tablon(1,wall_h*.3,wall_d*.5,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wall_l*.75+doorh_w*.5-1,wall_h*.15,wall_d*.25+1>
  }
  object{tablon(1,wall_h*.3,wall_d*.5,r_board,t_rdoor_wood)
   translate <-wall_l*.5+wall_l*.75-doorh_w*.5+1,wall_h*.15,wall_d*.25+1>
  }
  object{tablon(4,wall_d*.5,2,r_board,t_rdoor_wood)
   rotate 90*x
   translate <-wall_l*.5+wall_l*.25+doorh_w*.5-1,wall_h*.3+1,wall_d*.25+3>
  }
  object{tablon(4,wall_d*.5,2,r_board,t_rdoor_wood)
   rotate 90*x
   translate <-wall_l*.5+wall_l*.25-doorh_w*.5+1,wall_h*.3+1,wall_d*.25+3>
  }
  object{tablon(4,wall_d*.5,2,r_board,t_rdoor_wood)
   rotate 90*x
   translate <-wall_l*.5+wall_l*.5+doorh_w*.5-1,wall_h*.3+1,wall_d*.25+3>
  }
  object{tablon(4,wall_d*.5,2,r_board,t_rdoor_wood)
   rotate 90*x
   translate <-wall_l*.5+wall_l*.5-doorh_w*.5+1,wall_h*.3+1,wall_d*.25+3>
  }
  object{tablon(4,wall_d*.5,2,r_board,t_rdoor_wood)
   rotate 90*x
   translate <-wall_l*.5+wall_l*.75+doorh_w*.5-1,wall_h*.3+1,wall_d*.25+3>
  }
  object{tablon(4,wall_d*.5,2,r_board,t_rdoor_wood)
   rotate 90*x
   translate <-wall_l*.5+wall_l*.75-doorh_w*.5+1,wall_h*.3+1,wall_d*.25+3>
  }
  object{tablon(4,wall_d*.5,10,r_board,t_rdoor_wood)
   rotate 90*x
   translate <-wall_l*.5+wall_l*.25+doorh_w*.5-1,5,wall_d*.25+3>
  }
  object{tablon(4,wall_d*.5,10,r_board,t_rdoor_wood)
   rotate 90*x
   translate <-wall_l*.5+wall_l*.25-doorh_w*.5+1,5,wall_d*.25+3>
  }
  object{tablon(4,wall_d*.5,10,r_board,t_rdoor_wood)
   rotate 90*x
   translate <-wall_l*.5+wall_l*.5+doorh_w*.5-1,5,wall_d*.25+3>
  }
  object{tablon(4,wall_d*.5,10,r_board,t_rdoor_wood)
   rotate 90*x
   translate <-wall_l*.5+wall_l*.5-doorh_w*.5+1,5,wall_d*.25+3>
  }
  object{tablon(4,wall_d*.5,10,r_board,t_rdoor_wood)
   rotate 90*x
   translate <-wall_l*.5+wall_l*.75+doorh_w*.5-1,5,wall_d*.25+3>
  }
  object{tablon(4,wall_d*.5,10,r_board,t_rdoor_wood)
   rotate 90*x
   translate <-wall_l*.5+wall_l*.75-doorh_w*.5+1,5,wall_d*.25+3>
  }
 }
 // molduras
 union{
  difference{
   box{-.5,.5}
   cylinder{<-.6,-.5,0>,<.6,-.5,0>,.25}
   cylinder{<-.6,0,-.5>,<.6,0,-.5>,.25}
   cylinder{<-.6,-.5,-.5>,<.6,-.5,-.5>,.5}
  }
  cylinder{<-.5,0,0>,<.5,0,0>,.25}
  scale <wall_l,wall_d*.25,wall_d*.25>
  texture{t_ceil}
  rotate 180*y
  translate <0,wall_h-wall_d*.125,wall_d*.5>
 }
}
#declare corridor_ceil=
box{-.5,.5
 scale <corridor_w,ceil_t,wall_l>
 texture{t_ceil}
}
#declare rooms_ceil=
box{-.5,.5
 scale <wall_l,ceil_t,wall_l>
 texture{t_doors_wall}
}
#declare basic_wall=
box{-.5,.5
 scale <wall_l,wall_h,wall_d>
 texture{t_doors_wpaper}
 translate wall_h*.5*y
}

// floor
#if (use_parquet)
#declare R1=seed(0);
#declare R2=seed(15);
#declare R3=seed(24);
#declare R4=seed(14);
#declare R5=seed(69);
#declare num_baldosas = 18;
#declare num_filas = 3;
#declare cnt_bal=num_baldosas;
#declare cnt_fil=num_filas;
#if (use_final_text)
#declare t_mad_parquet=
texture{t_rdoor_wood
 scale 4
 rotate 90*y
}
texture{t_dirty}
#else
#declare t_mad_parquet=
texture{t_rdoor_wood
 scale 4
 rotate 90*y
}
#end
#declare ancho_baldosa = corridor_w*.5/num_filas;
#declare largo_baldosa = ancho_baldosa;
#declare grosor_baldosa = .5;
#declare baldosa=
height_field{
 png "p_hf"
 translate -.5
}
#declare corridor_floor=
union{
#while (cnt_fil>=-num_filas)
 #declare cnt_bal=num_baldosas;
 #while (cnt_bal>=-num_baldosas)
  object{baldosa
    rotate 90*y
    texture{
     material_map{
     tga "p_mm"
     texture{pigment{DarkTan}}
     #include "mad_gen.inc"
     #include "mad_gen.inc"
     #include "mad_gen.inc"

     #include "mad_gen2.inc"
     #include "mad_gen2.inc"
     #include "mad_gen2.inc"
     #include "mad_gen2.inc"

     #include "mad_gen.inc"
     #include "mad_gen.inc"
     #include "mad_gen.inc"
     #include "mad_gen.inc"

     #include "mad_gen2.inc"
     #include "mad_gen2.inc"
     #include "mad_gen2.inc"
     #include "mad_gen2.inc"

     #include "mad_gen.inc"
     }
     translate -.5
     rotate 90*x
    }
    scale <ancho_baldosa,grosor_baldosa,largo_baldosa>
    translate <(cnt_bal*largo_baldosa),0,cnt_fil*ancho_baldosa>
  }
  #declare cnt_bal=cnt_bal-1;
 #end
 #declare cnt_fil=cnt_fil-1;
#end
}
#else
#declare corridor_floor=
box{-.5,.5
 scale <wall_l,.1,corridor_w>
 texture{t_rdoor_wood}
}
#end

#declare rooms_floor=
box{-.5,.5
 scale <wall_l,ceil_t,wall_l>
 texture{t_rooms_floor}
 translate -ceil_t*.5*y
}
