#macro wall_light(r_lamp,lamp_on)

// declare work variables
#local lamp_color=wall_color;
#local light_color=(White*.5+Orange*.1)*2;
#local t_lamp=
#if (use_final_text)
texture{
 pigment{
  lamp_color filter .4 transmit .2
 }
}
//texture{t_dirtyvl translate 100*rand(r_lamp)}
#else
texture{
 pigment{
  lamp_color filter .4 transmit .2
 }
}
#end
#local k=.9+.2*rand(r_lamp);

// return the object
union{
 union{
  #if (use_wall_lights<2)
  difference{
   cone{<0,9,0>,5,<0,16,0>,3}
   cone{<0,8.9,0>,4.9,<0,16.1,0>,2.9}
   texture{t_lamp}
   hollow
   scale .999
  }
  #if (lamp_on)
  cone{<0,9,0>,5,<0,16,0>,3
   hollow
   texture{pigment{Clear}}
   interior{
     media {
      emission .1*k
      intervals 10
      samples 1, 10
      confidence 0.9999
      variance 1/1000
      density {
        cylindrical
        color_map {
          [0.0 light_color]
          [1.0 light_color]
        }
        frequency 1
      }
     }
   }
   scale .98
  }
  #end
  #end
  union{
   cylinder{<0,8.6,0>,<0,9,0>,0.9}
   cylinder{<0,9,0>,<0,10,0>,0.5}
   texture{pigment{White} finish{Shiny}}
  }
  union{
   torus{2.95,.08 translate 16.05*y}
   torus{4.95,.08 translate 8.85*y}
   cylinder{<0,8.55,0>,<0,8.65,0>,.85}
   cylinder{<0,8.85,-4.95>,<0,8.6,-.9>,.07}
   cylinder{<0,8.85,-4.95>,<0,8.6,-.9>,.07 rotate 120*y}
   cylinder{<0,8.85,-4.95>,<0,8.6,-.9>,.07 rotate -120*y}
   cylinder{<0,8.85,-4.9>,<0,16.05,-2.9>,.07}
   cylinder{<0,8.85,-4.9>,<0,16.05,-2.9>,.07 rotate 120*y}
   cylinder{<0,8.85,-4.9>,<0,16.05,-2.9>,.07 rotate -120*y}
   cylinder{<0,10,0>,<0,11,0>,0.3 no_shadow}
   texture{Gold_Texture}
  }
  rotate 360*rand(r_lamp)*y
  scale 1.6
  translate -14*y
 }
 union{
  union{
   cylinder{<0,0,0>,<0,-3,0>,1}
   intersection{
    torus{5,.7 rotate <90,90,0>}
    plane{y,0}
    translate <0,-3,5>
   }
   box{-.5,.5 scale <6,10,.5> translate <0,-6,10>}
   texture{Bronze_Metal}
  }
  // --- vase lamp light ---
  #if (lamp_on)
/*
  sphere{<0,0,0>,1
   pigment { color rgbf<1, 1, 1, 1> }
   finish { ambient 0 diffuse 0 }
   interior{
     media {
      emission .2*k
      intervals 10
      samples 1, 10
      confidence 0.9999
      variance 1/1000
      density {
        spherical
        cubic_wave
        turbulence .1
        color_map {
          [0.0 Black]
          [0.5 light_color*.1]
          [1.0 light_color]
        }
        frequency 1
      }
     }
   }
   no_shadow
   hollow
   scale 12
   translate 6*y
  }
  */
  sphere{<0,0,0>,1
   pigment { color rgbf<1, 1, 1, 1> }
   finish { ambient 0 diffuse 0 }
   interior{
     media {
      emission .25*k
      intervals 10
      samples 1, 10
      confidence 0.9999
      variance 1/1000
      density {
        spherical
        cubic_wave
        turbulence .1
        color_map {
          [0.0 Black]
          [1.0 light_color]
        }
        frequency 1
      }
     }
   }
   no_shadow
   hollow
   scale <3,4,3>
   translate 6*y
  }
  #if (usar_radiosidad)
   light_source{
    <0,6,0>
    light_color*k
    #if (usar_area)
    area_light <6,0,0>,<0,0,6>,4,4 adaptive 1 jitter
    #end
    fade_distance corridor_w*.5
    fade_power 2
   }
  #else
   light_source{
    <0,6,0>
    light_color*k
    #if (usar_area)
    area_light <6,0,0>,<0,0,6>,4,4 adaptive 1 jitter
    #end
    fade_distance corridor_w*.5
    fade_power 2
   }
  #end
  #end
 }
}

#end