// *** THAT'S MEGAPOV CODE ***
#version unofficial MegaPov 0.5;

#declare grass_texture=
texture{
 pigment{
  bozo
  turbulence 0.5
  color_map{
   [0.0 ForestGreen]
   [0.2 DarkTan]
   [0.8 DarkBrown]
   [1.0 DkGreenCopper]
  }
 }
 normal{granite 4 turbulence .2 scale .25}
 scale 10
}
#declare plant_pot=
union{
 union{
  intersection{
   difference{
    cylinder{<0,-8,0>,<0,8,0>,20}
    torus{20,8}
   }
   plane{y,0 inverse}
   plane{y,5.5 }
   scale 2
   translate 1.9*y
  }
  torus{24,1 translate 1*y}
  torus{28,1 translate 14*y}
  texture{
   pigment{Flesh}
   normal{bump_map{png "hf_rosa" map_type 2} scale 12}
   finish{Phong_Shiny reflection .1}
  }
 }
 height_field{
  png "hf_terr"
  water_level 0.1
  translate -.5
  scale <53,4,53>
  texture{grass_texture scale .1}
  translate 16*y
 }
 scale <.4,1.1,.4>
}
#declare num_leaves=10;
#declare cnt_leaves=0;
#declare rp=seed(89);
#declare min_height=6;
#declare max_height=12;
#declare base_radius=5;
#declare t_verde=
texture{
 pigment{
  gradient x
  turbulence 0.1
  color_map{
   [0.0 White]
   [0.02 White]
   [0.04 ForestGreen*.5+Gray20+Gold*.2]
   [1.0 DarkGreen]
  }
 }
 normal{bumps}
 finish{reflection .05}
 scale .7
}
#declare hierbajos=
union{
 #while (cnt_leaves<num_leaves)
  #declare kl=1;
  #declare medium_radius=.5+1*(1-(cnt_leaves/num_leaves));
  #include "h_leaf.inc"
  object{leaf
   scale .25+.25*(1-(cnt_leaves/num_leaves))
   texture{t_verde}
   rotate -40*(cnt_leaves/num_leaves)*x
   rotate (180*rand(rp))*y
   translate (cnt_leaves*max_height*.5/num_leaves)*y
  }
  #declare kl=1;
  #include "h_leaf.inc"
  object{leaf
   scale .25+.25*(1-(cnt_leaves/num_leaves))
   texture{t_verde}
   rotate -40*(cnt_leaves/num_leaves)*x
   rotate -(180*rand(rp))*y
   translate (cnt_leaves*max_height*.5/num_leaves)*y
  }
  #declare cnt_leaves=cnt_leaves+1;
 #end
}
#declare plant_pedestal=
union{
 cylinder{<0,0,0>,<0,2,0>,14}
 torus{12,2 translate 3*y}
 torus{10,2 translate 5*y}
 difference{
  cylinder{<0,5,0>,<0,35,0>,9}
  cylinder{<-9,5,0>,<-9,35,0>,2}
  cylinder{< 9,5,0>,<9,35,0>,2}
  cylinder{<0,5,0>,<0,35,-9>,2}
  cylinder{<0,5,0>,<0,35,9>,2}
  cylinder{<-9,5,0>,<-9,35,0>,2 rotate 45*y}
  cylinder{<-9,5,0>,<-9,35,0>,2 rotate 45*3*y}
  cylinder{<-9,5,0>,<-9,35,0>,2 rotate 45*5*y}
  cylinder{<-9,5,0>,<-9,35,0>,2 rotate 45*7*y}
 }
 torus{9,1 translate 35*y}
 torus{10,2 translate 37*y}
 cylinder{<0,37,0>,<0,40,0>,12}
 texture{t_doors_wall}
}
#declare corner_plant=
union{
 object{plant_pedestal}
 object{plant_pot
  translate <0,40.1,0>
 }
 union{
  object{hierbajos scale 4}
  object{hierbajos scale 4 rotate 90*y}
  translate <0,50,0>
 }
}
